//
// Created by webpigeon on 17/04/22.
//

#include <fggl/gui/widget.hpp>
#include <fggl/gui/widgets.hpp>

#include <spdlog/spdlog.h>

namespace fggl::gui {

	Button::Button( math::vec2 pos, math::vec2 size) : Widget(pos, size), m_hover(false), m_active(false) {}

	void Button::render(gfx::Paint &paint) {
		gfx::Path2D path{ topLeft() };
		draw_button(path, topLeft(), size(), m_hover, m_active);
		paint.fill(path);
	}

	void Button::activate() {
		m_active = !m_active;
		if ( m_active ) {
			for( auto& callback : m_callbacks ) {
				callback();
			}
		}
	}

	void Button::onEnter() {
		m_hover = true;
	}

	void Button::onExit() {
		m_hover = false;
	}

	void Button::addCallback(Callback cb) {
		m_callbacks.push_back( cb );
	}
} // namespace fggl::gui