//
// Created by webpigeon on 20/11/2021.
//

#include "Scene.h"

#include <utility>

namespace fggl::scenes {

    void SceneManager::create(const std::string &name, std::shared_ptr<Scene> scene) {
        m_scenes[name] = std::move(scene);
    }

    void SceneManager::activate(const std::string &name) {
        auto newScene = m_scenes.at(name);
        if ( m_active != nullptr ) {
            m_active->cleanup();
            m_active = nullptr;
        }
        newScene->setup();
        m_active = newScene;
    }

}