
#include "model.hpp"

namespace fggl::data {

	constexpr math::mat4 OFFSET_NONE(1.0f);

	Mesh make_triangle();

	// quads
	Mesh make_quad_xy();
	Mesh make_quad_xz();

	// simple shapes
	Mesh make_cube(Mesh &mesh, const math::mat4 &offset);

	inline Mesh make_cube(Mesh &mesh) {
		return make_cube(mesh, OFFSET_NONE);
	}

	// blockout shapes
	Mesh make_slope(Mesh &mesh, const math::mat4 &offset);

	inline Mesh make_slope(Mesh &mesh) {
		return make_slope(mesh, OFFSET_NONE);
	}

	Mesh make_ditch(Mesh &mesh, const math::mat4 &offset);

	inline Mesh make_ditch(Mesh &mesh) {
		return make_ditch(mesh, OFFSET_NONE);
	}

	Mesh make_point(Mesh &mesh, const math::mat4 &offset);

	inline Mesh make_point(Mesh &mesh) {
		return make_point(mesh, OFFSET_NONE);
	}
}
