#ifndef FGGL_ECS_UTILITY_H
#define FGGL_ECS_UTILITY_H

#include <cstdint>

namespace fggl::ecs {

	using IDType = std::uint32_t;
	using entity_t = IDType;
	using component_type_t = IDType;

	constexpr IDType NULL_ENTITY = 0;

	template<class T>
	class TypeIdGenerator {
		private:
			static IDType m_count;
		public:
			template<class U>
			static const IDType GetNewID() {
				static const IDType idCounter = m_count++;
				return idCounter;
			}
	};

	template<class T> IDType TypeIdGenerator<T>::m_count = 0;
}

#endif
