#ifndef FGGL_UTILS_H
#define FGGL_UTILS_H

#include <cstddef>

namespace fggl::utils {

	template<typename T>
	std::size_t search(const T *data, const std::size_t size, const T &v) {
		// empty list == not found
		if (size == 0) {
			return size;
		}

		std::size_t left = 0;
		std::size_t right = size - 1;
		while (left <= right) {
			std::size_t m = (left + right) / 2;
			if (data[m] == v) {
				return m;
			} else if (v < data[m]) {
				if (m == 0) {
					return size;
				}
				right = m - 1;
			} else {
				left = m + 1;
			}
		}

		return size;
	}

}

#endif
