#include <functional>
#include <memory>

namespace fggl::gfx {

	class RenderBackend {
		public:
			RenderBackend();
			virtual ~RenderBackend() = default;

			virtual void clear() = 0;
			virtual void swap() = 0;

	};

	using RenderBackendPtr = std::unique_ptr<RenderBackend>;
	using RenderBackendFactory = std::function<fggl::gfx::RenderBackendPtr &&()>;

};
