#ifndef FGGL_GUI_WIDGETS_H
#define FGGL_GUI_WIDGETS_H

#include <functional>
#include <fggl/gui/widget.hpp>

namespace fggl::gui {

	using Callback = std::function<void(void)>;

	class Button : public Widget {
		public:
			Button() = default;
			Button(math::vec2 pos, math::vec2 size);

			void render(gfx::Paint &paint) override;

			void activate() override;
			void onEnter() override;
			void onExit() override;

			void addCallback(Callback cb);
		private:
			const std::string m_value;
			std::vector<Callback> m_callbacks;
			bool m_hover;
			bool m_active;
	};

	class Label : public Widget {
		public:
			Label();
			void render(gfx::Paint &paint) override;
	};

	class TextField : public Widget {
		public:
			TextField();
			void render(gfx::Paint &paint) override;
	};

	class Toggle : public Widget {
		public:
			Toggle();
			void render(gfx::Paint &paint) override;
	};

}; //namespace fggl::gui

#endif
