#ifndef FGGL_SCENES_MENU_H
#define FGGL_SCENES_MENU_H

#include <functional>
#include <map>
#include <memory>

#include <fggl/app.hpp>
#include <fggl/math/types.hpp>
#include <fggl/input/input.hpp>
#include <fggl/gui/gui.hpp>

namespace fggl::scenes {

	using callback = std::function<void(void)>;

	class BasicMenu : public AppState {
		public:
			BasicMenu(App &owner);

			void update() override;
			void render(gfx::Paint &paint) override;

			void activate() override;
			void deactivate() override;

			void add(const std::string &label, callback cb);

		private:
			std::shared_ptr<input::Input> m_inputs;
			std::map<const std::string, callback> m_items;

			// menu state
			std::string m_active;
			math::vec2 m_cursorPos;
			gui::Container m_canvas;
			gui::Widget* m_hover;
	};

} // namepace fggl::scenes

#endif
